/*
 * 	Doku, siehe http://www.mikrocontroller.net/articles/AVR_FAT32
 *  Neuste Version: http://www.mikrocontroller.net/svnbrowser/avr-fat32/
 *	Autor: Daniel R.
 */

#include <stdlib.h>
#include <LPC214x.H> //#include <avr/io.h>

#include "config.h"	// Hier werden alle nötigen Konfigurationen vorgenommen, umbedingt anschauen !
#include "file.h"
#include "fat.h"
#include "mmc.h"		// Hardware abhängig
#include "uart.h"		// Hardware abhängig, es kann auch eine eigene eingebunden werden !

#define DEBUG 1
//*****************************************************************************************************************
int main(void){
	
	#if(MMC_LFN_SUPPORT==TRUE)
		unsigned char file_name[]="test.txt";
	#else
		unsigned char file_name[]="TEST    TXT";
	#endif

	// String zum in die Datei schreiben.
	unsigned char str[]="Hallo Datei!";
	unsigned long int seek;


	// Uart initialisierung zu Ausgabe von Daten
	uinit();

	uputs((unsigned char*)"\nBoot");

	// Versuch Karte zu Initialisieren, bis es klappt. Umbedingt so, weil die Initialiesierung nicht immer auf anhieb klappt.
	while (FALSE==mmc_init()){
		nop();
	}

	uputs((unsigned char*)"...");


	// Fat initialisieren. Nur wenn das klappt sind weitere Aktionen sinnvoll, sonst aendet das Programm !
	if(TRUE == fat_loadFatData()){

	  uputs((unsigned char*)"Ok\n");		// Wenn auf dem terminal "Boot... OK" zu lesen ist, ist Init OK. Jetzt kann man schreiben/anhaengen/lesen

	  // In der config.h kann eingestellt werden, ob mit oder ohne lange Dateinamen Unterstuetzung kompiliert wird !
	  
	  // Nur wenn schreiben Option in der config.h TRUE ist wird geschrieben bzw. angehangen!
	  #if (MMC_WRITE==TRUE)

		  // Datei existiert nicht, also anlegen !
		  if(MMC_FILE_NEW == ffopen(file_name)){
			 #if (DEBUG)
			 	uputs((unsigned char*)"Datei neu anlegen...");
			#endif
			 // Schreibt String auf Karte ! Nur richtige Strings koennen mit ffwrites geschrieben werden !
			 ffwrites(str);

			 // Neue Zeile in der Datei
			 ffwrite(0x0D);
			 ffwrite(0x0A);

			 // Schließt Datei
			 ffclose();
			 #if (DEBUG)
			 	uputs((unsigned char*)"Ok\n");
			 #endif
		   }




		   // Datei existiert, also anhaengen !
		  if(MMC_FILE_EXISTS == ffopen(file_name)){
			#if (DEBUG)
			 	uputs((unsigned char*)"An Datei anhaengen...");
			#endif
			 ffseek(file.length);   // Spult bis zum Dateiende vor um anzuhaengen, geht auch ohne Option MMC_OVER_WRITE !

			 // schreibt String
			 ffwrites(str);

			 // neue Zeile in der Datei
			 ffwrite(0x0D);
			 ffwrite(0x0A);

			 // schliet Datei
			 ffclose();
			#if (DEBUG)
			 	uputs((unsigned char*)"Ok\n");
			#endif
		   }

	   #endif


	   // Datei existiert also lesen. Gerade angelegt und beschrieben, oder war schon vorhanden und es wurde was angehaengt.
	   if(MMC_FILE_EXISTS == ffopen(file_name)){
		  #if (DEBUG)
			 	uputs((unsigned char*)"Datei lesen:\n");
			#endif
	      // setzen einer Variable und dann runterzaehlen geht am schnellsten !
	      seek=file.length;

	      // lesen eines chars und Ausgabe des chars.
	      // solange bis komplette Datei gelesen wurde.
	      do{
	         uputc(ffread());
	      }while(--seek);

	      ffclose();
		  #if (DEBUG)
			 	uputs((unsigned char*)"\nOkn");
		  #endif
	   }




	  }
	  while(1);
}
